package sim;

import team.gui.Coord;

public class CoordChannel extends Channel
{
	public static double MARGIN = 0.00000001;
	private double _margin = MARGIN;
	
	public CoordChannel(Entity e)
	{
		super(e);
	}
	
	public void setMargin(double margin)
	{
		this._margin = margin;
	}
	
	public void write(Coord coord)
	{
		writeObject(coord.copy());
	}
	
	protected boolean checkData(Object d, Object b)
	{
		if(b != null && d != null)
		{
			Coord coord = (Coord)d;
			Coord tmp = (Coord)b;
			
			if(Math.abs(coord.x - tmp.x) < _margin && Math.abs(coord.y - tmp.y) < _margin)
				return false;
		}
		
		return true;
	}
	
	public Coord read()
	{
		return (Coord)super.readObject();
	}
	
	public Coord[] readAll()
	{
		Object[] os = readObjects();
		Coord[] ret = new Coord[os.length];
		for(int i = 0; i < os.length; i++)
			ret[i] = (Coord)os[i];
		
		return ret;
	}
	
	public Coord getState()
	{
		return (Coord)super.getStateObject();
	}
	
	public void initState(Coord coord)
	{
		super.initStateObject(coord.copy());
	}
}
