package sim;

public class DoubleChannel extends Channel
{
	public static double MARGIN = 0.00000001;
	private double _margin = MARGIN;

	public DoubleChannel(Entity e)
	{
		super(e);
		initState(0);
	}
	
	public void setMargin(double margin)
	{
		this._margin = margin;		
	}
	
	public void write(double value)
	{
		super.writeObject(new Double(value));
	}
	
	public void write(double value, int ch)
	{
		super.writeObject(new Double(value),ch);
	}
	
	protected boolean checkData(Object d, Object b)
	{
		//if(data != null)
		{
			double value = ((Double)d).doubleValue();
			double tmp = value - ((Double)b).doubleValue();
			
			if(Math.abs(tmp) < _margin)
				return false;
		}		
		
		return true;
	}
	
	public double read()
	{
		Double d = (Double)super.readObject();
		if(d == null)
			return 0;
		
		return d.doubleValue();
	}
	
	public double[] readAll()
	{
		Object[] os = readObjects();
		double[] ret = new double[os.length];
		for(int i = 0; i < os.length; i++)
			ret[i] = ((Double)os[i]).doubleValue();
		
		return ret;
	}
	
	public double getState()
	{
		return ((Double)super.getStateObject()).doubleValue();
	}
	
	public void initState(double value)
	{
		super.initStateObject(new Double(value));
	}
}
