package sim.test;

import sim.DoubleChannel;
import sim.Entity;
import sim.Sim;

public class Box extends Entity
{
	public DoubleChannel in_delta = new DoubleChannel(this);
	public DoubleChannel in_accel = new DoubleChannel(this);
	
	public DoubleChannel out_pos = new DoubleChannel(this);
	public DoubleChannel out_vel = new DoubleChannel(this);
	
	public DoubleChannel in_acu_force = new DoubleChannel(this);
	public DoubleChannel out_acu_force = new DoubleChannel(this);
	
	private double m = 1;
	
	public Box(Sim sim, double mass, double pos)
	{
		super(sim);
		this.m = mass;
		this.out_pos.initState(pos);
		this.out_vel.initState(0);
	}
	
	protected void read()
	{
		System.out.println("Acc: " + in_accel.read() + 
				", vel: " + out_vel.read() + 
				", pos: " + out_pos.read());
	}
	
	protected void tick()
	{		
		out_vel.write(out_vel.getState() + in_accel.read() * in_delta.read());
		out_pos.write(out_pos.getState() + out_vel.read() * in_delta.read());		
		out_acu_force.write(in_acu_force.read() + m*in_accel.read());
	}
}
