package sim.test;

import sim.DoubleChannel;
import sim.Entity;
import sim.ISolver;
import sim.Sim;

public class Solver extends Entity implements ISolver
{
	public DoubleChannel in_target = new DoubleChannel(this);
	
	public DoubleChannel in_signal = new DoubleChannel(this);	
	public DoubleChannel out_testsignal = new DoubleChannel(this);
	
	private double btree_value;
	private boolean start;

	public Solver(Sim sim)
	{
		super(sim);
		out_testsignal.initState(0);
	}
	
	protected void read()
	{
		btree_value = 20;
		start = true;
	}

	protected void tick()
	{	
		//System.out.print("in_acu_force " + in_acu_force.read() + ", target: " + in_target_force.read());
		
		
		
		if(start && !(btree_value < 0.0001))
		{
			start = false;
			getSim().regSolv(this);
		}
		
		//System.out.println(" -> test_acc: " + out_test_accel.read());
	}
	
	public void stableInputs()
	{
		System.out.print("in_acu_force " + in_signal.read() + ", target: " + in_target.read());
		
		if(in_signal.read() < in_target.read())
			out_testsignal.write(out_testsignal.read() + btree_value);
		else
			out_testsignal.write(out_testsignal.read() - btree_value);
		
		btree_value /= 2;
		start = true;
		
		System.out.println(" -> test_acc: " + out_testsignal.read());
	}
}
