package sim.test;

import sim.DoubleChannel;
import sim.Entity;
import sim.Sim;

public class Spring extends Entity
{
	public DoubleChannel accel_a = new DoubleChannel(this);
	public DoubleChannel accel_b = new DoubleChannel(this);
	
	public DoubleChannel delta = new DoubleChannel(this);
	public DoubleChannel rvel = new DoubleChannel(this);
	public DoubleChannel rpos = new DoubleChannel(this);
	
	public DoubleChannel force = new DoubleChannel(this);
	
	
	public Spring(Sim sim)
	{
		super(sim);
		rvel.initState(0);
		rpos.initState(0);
	}

	protected void tick()
	{
		double da = accel_a.read() - accel_b.read();
		rvel.write(rvel.getState() + da*delta.read());
		rpos.write(rpos.getState() + rvel.read()*delta.read());
		
		force.write(rpos.read()*10);
	}
	
	protected void post_tick()
	{
		
	}
}
