package sim.test;

import sim.Constant;
import sim.Sim;
import sim.Time;

public class Test
{
	public static void main(String[] args) throws Exception
	{
		Sim sim = new Sim();
		
		Time time = new Time();
		time.io_delta.initState(0.1);
		
		Comperator comp = new Comperator();		
		comp.in_a.connect(time.out_time);
		comp.in_b.connect(new Constant(1));
		comp.out_if_ina_bigger.connect(new Constant(0));
		comp.out_if_inb_bigger.connect(new Constant(2));
		
		Solver solver1 = new Solver(sim);
		Solver solver2 = new Solver(sim);
		
		Box box1 = new Box(sim,2,1);
		Box box2 = new Box(sim,2,2);
		Box box3 = new Box(sim,3,3);
		
		Strut strut = new Strut(sim);
		Spring spring = new Spring(sim);
		
		solver1.in_target.connect(comp.out);
		solver1.in_signal.connect(box1.out_acu_force);
		
		box1.in_accel.connect(solver1.out_testsignal);
		box1.in_delta.connect(time.io_delta);
		box1.in_acu_force.connect(new Constant(0));
		
		strut.accel_i.connect(box1.in_accel);
		strut.f_acu_i.connect(box2.out_acu_force);
		
		box2.in_accel.connect(strut.accel_o);
		box2.in_delta.connect(time.io_delta);
		box2.in_acu_force.connect(new Constant(0));
		
		spring.accel_a.connect(box2.in_accel);
		spring.accel_b.connect(box3.in_accel);
		spring.delta.connect(time.io_delta);
		
		solver2.in_target.connect(spring.force);
		
		sim.play(3, 50);
	}
}
