package sim.test2;

import sim.DoubleChannel;
import sim.Entity;

public class Box extends Entity
{
	public DoubleChannel in_force = new DoubleChannel(this);	
	public DoubleChannel in_delta = new DoubleChannel(this);
	
	public DoubleChannel out_accel = new DoubleChannel(this);	
	public DoubleChannel out_pos = new DoubleChannel(this);
	public DoubleChannel out_vel = new DoubleChannel(this);
	
	private double m;
	
	public Box(double mass, double pos)
	{
		this.m = mass;
		this.out_pos.initState(pos);
		this.out_vel.initState(0);
	}
	
	protected void read()
	{
		if(getSim().isDebugOn())
			System.out.println("Acc: " + out_accel.read() + 
				", vel: " + out_vel.read() + 
				", pos: " + out_pos.read());
	}

	protected void tick()
	{		
		out_accel.write(in_force.read() / m);
		out_vel.write(out_vel.getState() + out_accel.read() * in_delta.read());
		out_pos.write(out_pos.getState() + out_vel.read() * in_delta.read());
	}
}
