package sim.test2;

import sim.DoubleChannel;
import sim.Entity;
import sim.Integrator;

public class Box2 extends Entity
{
	public DoubleChannel in_force = new DoubleChannel(this);
	
	public DoubleChannel out_accel = new DoubleChannel(this);	
	public DoubleChannel out_pos = new DoubleChannel(this);
	public DoubleChannel out_vel = new DoubleChannel(this);

	private double m;
	
	public Box2(double m, double pos)
	{
		this.m = m;
		
		Integrator acc_vel = new Integrator();
		Integrator vel_pos = new Integrator();
		
		acc_vel.connectTest(out_accel);
		vel_pos.connect(acc_vel);
		
		out_vel.connect(acc_vel.out);
		out_pos.connect(vel_pos.out);
		
		out_pos.initState(pos);
	}
	
	public void tick()
	{
		out_accel.write(in_force.read() / m);
	}
}
