package sim.test2;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.swing.JFrame;

import ptolemy.plot.Plot;
import ptolemy.plot.PlotFrame;
import sim.Channel;
import sim.Entity;
import backup.div.Excel;

public class Logger extends Entity
{
	public Channel in = new Channel(this);
	
	private ArrayList data = new ArrayList();
	private HashMap label = new HashMap();
	
	private Excel e;
	private Plot p;
	private PlotFrame f;
	private int last_row = 0;

	private int mod_value = 1;
	private int count = 0;
	
	private double xbigger = Double.MIN_VALUE;

	private String title = "Plot";
	
	public Logger()
	{
	}
	
	public Logger(String title)
	{
		this.title = title;		
	}

	
	public void setMod(int mod_value)
	{
		this.mod_value = mod_value;		
	}
	
	public void setLogXValuebigger(double value)
	{
		xbigger = value;
	}
	
	public void connect(Channel c, String label)
	{
		super.connectTest(c);
		this.label.put(c, label);
	}
	
	public int numColumns()
	{
		return in.getConnectedChannels().size();
	}
	
	public int numRows()
	{
		return data.size();
	}
	
	public String getColumnName(int col)
	{
		Channel c = (Channel)in.getConnectedChannels().get(col);
		
		String l = (String) label.get(c);
		if(l == null)
			return c.getName();
		else
			return l;
	}
	
	public Object get(int col, int row)
	{
		Object[] d = (Object[]) data.get(row);
		return d[col];
	}
	
	private void _plot()
	{
		int numc = numColumns();
		int numr = numRows();
		
		for(int i = last_row; i < numr; i++)
		{
			Double x = (Double)get(0, i);
			if(x == null)
				continue;
			
			for(int j = 1; j < numc; j++)
			{
				Double y = (Double)get(j, i);
				if(y == null)
					continue;
				
				p.addPoint(j-1, x.doubleValue(), y.doubleValue(), true);
			}
			last_row = i;
		}
		
		
		updatePlot();
	}
	
	public void toPlot()
	{
		if(p == null)
			p = new Plot();
		
		_plot();
		
		int numc = numColumns();
		for(int i = 1; i < numc; i++)
			p.addLegend(i-1, getColumnName(i));
		
		
		f = new PlotFrame(title,p);
		f.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		f.setSize(400, 300);
		f.setLocation(300, 610);
		f.setVisible(true);
		
	}
	
	public void updatePlot()
	{
		if(f != null)
			f.repaint();
	}
	
	private void _excel()
	{
		try
		{
			int numc = numColumns();
			
			for(int i = last_row; i < numc; i++)
			{
				e.write(i, 0, getColumnName(i));
				last_row = i;
			}
		} catch (Exception e)
		{
			e.printStackTrace();
		}		
	}
	
	public void toExcel()
	{
		try
		{
			if(e == null)
			{
				e = new Excel();
				e.newBook();
			}
			
			_excel();
			
			int numc = numColumns();
			int numr = numRows();			
			
			for(int col = 0; col < numc; col++)
			for(int row = 0; row < numr; row++)
			{
				e.write(col, row+1, get(col, row));
			}			
		} catch (Exception e)
		{
			e.printStackTrace();
		}		
	}
	
	protected void read()
	{
		
		List list = in.getConnectedChannels();
		Object[] d = new Object[list.size()];
		
		for(int i = 0; i < list.size(); i++)
		{
			d[i] = ((Channel)list.get(i)).readObject();
		}
		
		if(((Double)d[0]).doubleValue() < xbigger)
			return;
		
		data.add(d);
		
		if(count % mod_value == 0)
		{
			if(e != null)
				_excel();
			else if(p != null)
				_plot();
		}
		
		count++;
	}
}
