package sim.test2;

import sim.DoubleChannel;
import sim.Entity;

public class Spring extends Entity
{
	public DoubleChannel in_delta = new DoubleChannel(this);
	public DoubleChannel in_acc = new DoubleChannel(this);
	
	public DoubleChannel out_force = new DoubleChannel(this);

	private DoubleChannel s_vel = new DoubleChannel(this);
	private DoubleChannel s_pos = new DoubleChannel(this);
	
	private double k;

	public Spring(double k)
	{
		this.k = k;
		
		s_vel.initState(0);
		s_pos.initState(0);
	}
	
	protected void read()
	{
		if(getSim().isDebugOn())
			System.out.println("Outforce: " + out_force.read()
					+ ", in_acc: " + in_acc.read()
					+ ", s_vel: " + s_vel.read()
					+ ", s_pos: " + s_pos.read());
	}

	protected void tick()
	{
		s_vel.write(s_vel.getState() + in_acc.read() * in_delta.read());
		s_pos.write(s_pos.getState() + s_vel.read() * in_delta.read());
		
		out_force.write(s_pos.read() * k);
	}
}
