package sim.test2;

import sim.Constant;
import sim.Sim;
import sim.Time;
import sim.test.Comperator;

public class Test
{	
	public static void main(String[] args) throws Exception
	{
		Sim sim = new Sim();
		
		Time time = new Time();
		sim.autoConnect(time.io_delta);
		time.io_delta.initState(0.01);		
		
		Box2 boxA = new Box2(1, 0);
		Box2 boxB = new Box2(2, 0);
		Spring spring = new Spring(1);
		Damper damper = new Damper(0.2);
		Comperator comp = new Comperator();
		
		
		
		spring.in_acc.connect(new Adder().connect(boxA.out_accel)
				.connect(new Negate().connect(boxB.out_accel)));
		
		damper.in_acc.connect(new Adder().connect(boxA.out_accel)
				.connect(new Negate().connect(boxB.out_accel)));
		
		comp.in_a.connect(new Constant(2));
		comp.in_b.connect(time.out_time);
		comp.out_if_ina_bigger.connect(new Constant(1));
		comp.out_if_inb_bigger.connect(new Constant(0));

		boxA.in_force.connect(new Adder()
				.connect(comp)
				.connect(new Negate().connect(spring.out_force))
				.connect(new Negate().connect(damper.out_force)));		
		

		boxB.in_force.connect(new Adder()
				.connect(spring.out_force)
				.connect(damper.out_force));
		
		Logger log = new Logger("Plot box-spring-damper");
		log.connectTest(time.out_time);
		log.connect(boxA.out_pos, "Box A");
		log.connect(boxB.out_pos, "Box B");
		//log.toPlot();
		
		//box1.out_accel.setMargin(0.01);
		//box2.out_accel.setMargin(0.01);
		
		sim.setDebug(true);
		sim.setDebugMod(1000);
		sim.setDebugLevel(5);
		sim.play(2000, 100);
		//log.updatePlot();
		log.toPlot();
	}
}
