package sim.test3;

import java.util.ArrayList;
import java.util.List;

import sim.Entity;

public abstract class MultiPort extends Entity implements ISingle
{
	private List comps = new ArrayList();
	
	private char sig = 'Z';
	private char next_sig = 'Z';

	private String id;
	
	public MultiPort(String id)
	{
		this.id = id;
	}
	
	public MultiPort()
	{
	}
	
	public void connectSignal(ISingle comp)
	{
		comps.add(comp);
	}
	
	public char getSignal()
	{
		return sig;
	}
	
	public void read()
	{
		if(id != null)
			System.out.println(id + " sig: " + getSignal());
		
		char prev = ((ISingle) comps.get(0)).getSignal();
		for(int i = 1; i < comps.size(); i++)
		{
			ISingle comp = (ISingle) comps.get(i);
			char s = comp.getSignal();			
			prev = op(s,prev);	
		}
		
		if(comps.size() == 1)
			prev = op(prev,prev);
		
		next_sig = prev;
	}
	
	protected abstract char op(char a, char b);	
	
	public void write()
	{
		sig = next_sig;
	}
}
