package team.app;

import idb.dom.Node;

import java.awt.Image;
import java.util.List;

import team.gui.CoordTransform;
import team.gui.InputGUI;
import team.gui.MapPainter;
import team.gui.ShapePainter;
import team.gui.WorldPainter;

public class App implements IConfig
{
	//public World sim = new World();
	
	public WorldPainter world_p = new WorldPainter();
	public MapPainter map_p = new MapPainter(world_p);
	public ShapePainter shape_p = new ShapePainter(world_p);
	
	public IConfig conf = new StdConfig();
	
	public App() throws Exception
	{
		
	}
	
	public void show()
	{
		WorldPainter.show(world_p);
		InputGUI.getBuilder();
		InputGUI.setVisible(true);
	}
	
	public Node getConfig(String file)
	{
		return conf.getConfig(file);
	}
	
	public Image loadImage(String file)
	{
		return conf.loadImage(file);
	}
	
	public void loadMaps()
	{
		List list = getConfig("arg.txt").nodes("map");
		for(int i = 0; i < list.size(); i++)
		{
			Node m = (Node) list.get(i);
			if(m.node("x") != null)
				continue;
			
			map_p.addImage(m.nodeText("img"), new CoordTransform(Double.parseDouble(m.nodeText("l1x")),
					Double.parseDouble(m.nodeText("l1y")),
					Double.parseDouble(m.nodeText("l2x")),
					Double.parseDouble(m.nodeText("l2y")),
					Double.parseDouble(m.nodeText("w1x")),
					Double.parseDouble(m.nodeText("w1y")),
					Double.parseDouble(m.nodeText("w2x")),
					Double.parseDouble(m.nodeText("w2y")),
					world_p.getWorldTransform()));
		}
	}
}
