package team.app.delay;

public class Filter
{	
	public static double[] filter(IFilter filter, double[] data)
	{
		return filter(filter,data,data.length);
	}
	
	public static double[] filter(IFilter filter, double[] data, int size)
	{
		double[] out = new double[size];
		for(int i = 0; i < size; i++)
		{
			double value = 0;
			double weigth = 0;
			
			for(int j = 0; j < size; j++)
			{
				double s = filter.getScale(j-i);
				value += data[j] * s;
				weigth += s;
				
			}
			out[i] = value/weigth;			
		}
		
		return out;
	}
	
	public static double[] myFilter(double[] data, int size)
	{
		double[] out = new double[size];
		
		for(int i = 2; i < size-2; i++)
		{
			double inm2 = data[i-2];
			double inm1 = data[i-1];
			double ins = data[i];
			double inp1 = data[i+1];
			double inp2 = data[i+2];
			
			double v = (inm2+inm1+ins+inp1+inp2)/5;			
			out[i] = v;	
		}
		
		out[1] = out[2] - (out[3] - out[2]);
		out[0] = out[1] - (out[2] - out[1]);
		
		out[size-2] = out[size-3] + (out[size-3]-out[size-4]);
		out[size-1] = out[size-2] + (out[size-2]-out[size-3]);
		
		return out;
	}
	
	public static IFilter createAvg(final double filter_size)
	{
		return new IFilter() {
			public double getScale(int index)
			{
				index = Math.abs(index);
				int ifilter_size = (int)filter_size;
				
				if(index == 0)
					return 1;		
				else if(index < ifilter_size)
					return 1;
				else if(index == ifilter_size)
					return filter_size - ifilter_size;
				else
					return 0;
			}};
	}
	
	public static void main(String[] args) throws Exception
	{
		double[] tmp = new double[]{0,0,0,5};
		tmp = filter(createAvg(4), tmp);
		
		for(int i = 0; i < tmp.length; i++)
			System.out.print(tmp[i]+" ");
		
	}
}
