package team.app.delay;

import team.app.system.ScheduleCalc;


public class Interpolate
{	
	private double[] y;
	private double[] x;

	public Interpolate(double[] y, double[] x)
	{
		this.y = y;
		this.x = x;
	}
	
	public double getY(double lx)
	{		
		if(lx < x[0])
			return y[0];
		else if(lx > x[x.length-1])
			return y[y.length-1];
		
		int index = 0;
		for(int i = 1; i < x.length; i++)
		{
			if(lx < x[i])
			{
				index = i;
				break;
			}
		}
		
		return ScheduleCalc.interpolate(y[index-1],y[index],ScheduleCalc.ratio(x[index-1],x[index], lx));
	}
	
	public double[] toArray(int steps)
	{
		double[] out = new double[steps];
		double step = (x[x.length-1] - x[0]) / ((double)steps);
		
		int index = 0;
		for(double i = x[0]; index < out.length; i+=step)
			out[index++] = getY(i);
		
		return out;
	}
	
	public static void main(String[] args) throws Exception
	{
		double[] x = new double[] {0,2,4,6,8,10}; 
		double[] y = new double[] {5,6,6,8,9,10};
		
		Interpolate i = new Interpolate(y,x);
		System.out.println(i.getY(2));
		System.out.println(i.getY(3));
		System.out.println(i.getY(4));
	}
}
