package team.app.delay;

import org.jscience.mathematics.numbers.Float64;
import org.jscience.mathematics.vectors.Matrix;

import team.app.delay.Plot.Plotter;
import team.app.div.Random;

public class Kalman
{
	
	public Kalman()
	{
		
	}
	
	public void set(double value)
	{
		
	}
	
	public double reg(double value)
	{
		return 0;
	}
	
	public static void kalman(double duration, double dt)
	{
		Plot p = new Plot();
		Plotter px1 = p.getPlotter("x1");
		Plotter px2 = p.getPlotter("x2");
		Plotter pz = p.getPlotter("z1");
		Plotter pxh1 = p.getPlotter("xhat1");
		Plotter pxh2 = p.getPlotter("xhat2");
		
		
		
		double measnoise = 10;
		double accelnoise = 0.5;
		
		Matrix X = Matrix.valueOf(new double[][] {{0},{0}});
		Matrix A = Matrix.valueOf(new double[][] {{1,dt},{0,1}});
		Matrix H = Matrix.valueOf(new double[][] {{1,0}});		
		
		Matrix Xhat = X;
		
		Matrix Q = Matrix.valueOf(new double[][] {{Math.pow(dt, 4)/4,Math.pow(dt, 3)/2},
				{Math.pow(dt, 3)/2,Math.pow(dt, 2)/1}});
		Q = Q.times(Float64.valueOf(accelnoise));
		
		Matrix P = Q;
		Matrix R = Matrix.valueOf(new double[][] {{Math.pow(measnoise,2)}});
		
		int i = 0;
		for(double t = 0; t < duration; t+=dt)
		{
			i++;
			
			Matrix ProcesssNoise = Matrix.valueOf(new double[][] {{Math.pow(dt,2)/2*Random.randn()},{dt*Random.randn()}});
			
			X = A.times(X).plus(ProcesssNoise);
			
			Matrix MeasNoise = Matrix.valueOf(new double[][] {{ measnoise * Random.randn()}});
			Matrix Z = H.times(X).plus(MeasNoise);
			
			Matrix Inn = Z.minus(H.times(Xhat));
			Matrix S = H.times(P).times(H.transpose()).plus(R);
			
			Matrix K = A.times(P).times(H.transpose()).times(S.inverse());
			Xhat = A.times(Xhat).plus(K.times(Inn));
			P = A.times(P).times(A.transpose()).plus(Q).minus(A.times(P).times(H.transpose()).times(S.inverse()).times(H).times(P).times(A.transpose()));
			
			System.out.println(X);
			System.out.println();
			
			px1.plot(X.get(0, 0));
			px2.plot(X.get(1, 0));
			pz.plot(Z.get(0, 0));
			pxh1.plot(Xhat.get(0, 0));
			pxh2.plot(Xhat.get(1, 0));
			
			p.step(dt);
		}
		
		p.setVisible(true);
	}
	
	public static void main(String[] args) throws Exception
	{
		Matrix A = Matrix.valueOf(new double[][] {{1,0},{0,1}});		
		kalman(30,0.2);
	}
}
