package team.app.delay;

import javax.swing.JFrame;

import org.jscience.mathematics.numbers.Number;
import org.jscience.mathematics.structures.Field;

import ptolemy.plot.PlotFrame;
import team.app.div.Random;

public class Plot
{
	private ptolemy.plot.Plot p;
	private PlotFrame f;
	
	private double x = 0;
	private int free_dataset = 0;
	
	private int size = 0;
	private double[] xv = new double[100000];
	
	public Plot()
	{
		this("Plotter");
	}
	
	public Plot(String title)
	{
		p = new ptolemy.plot.Plot();
		
		f = new PlotFrame(title,p);
		f.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		//f.setSize(500, 400);
		f.setSize(800, 600);
	}
	
	public void setLine()
	{
		
	}
	
	public void setPoint()
	{
		p.setMarksStyle("points");
		p.setConnected(false);
	}
	
	public void step()
	{
		setX(getX()+1);
	}
	
	public void step(double step)
	{
		setX(getX()+step);
	}
	
	public void setX(double x)
	{
		xv[size++] = x;
		this.x = x;
	}
	
	public double getX()
	{
		return x;
	}
	
	public Plotter getPlotter(String name)
	{
		if(name != null)
			p.addLegend(free_dataset, name);
		return new Plotter(this, free_dataset++);
	}
	
	public void plot(int dataset, double value)
	{
		p.addPoint(dataset, x, value, true);
	}
	
	public void plot(int dataset, double x, double value)
	{
		p.addPoint(dataset, x, value, true);
	}
	
	public void setVisible(boolean visible)
	{
		f.setVisible(visible);
	}
	
	
	
	public static class Plotter
	{
		private final Plot p;
		private final int dataset;

		public Plotter(Plot p, int dataset)
		{
			this.p = p;
			this.dataset = dataset;			
		}
		
		public void clear()
		{
			p.p.clear(dataset);
		}
		
		public void plot(double[] data)
		{
			clear();
			for(int i = 0; i < data.length; i++)			
				p.plot(dataset, i, data[i]);
		}
		
		public void plot(double value)
		{
			p.plot(dataset, value);
		}
		
		public void plot(double x, double value)
		{
			p.plot(dataset, x, value);
		}
		
		public void plot(Field f)
		{
			if(f instanceof Number)			
				p.plot(dataset,((Number)f).doubleValue());
			else
				throw new RuntimeException("Kan ikke plotte: " + f);
		}
	}
	
	public static void main(String[] args) throws Exception
	{
		Plot p = new Plot();
		p.setPoint();
		Plotter y = p.getPlotter("rand");
		for(int i = 0; i < 10000; i++)
		{
			p.setX(Random.randn(100, 1));
			y.plot(Random.randn(100, 1));			
		}
		p.setVisible(true);
	}
}
