package team.app.div;

import javax.swing.JLabel;

import sim.ISample;
import team.gui.InputGUI;
import team.sim.Event;
import team.sim.IListener;
import team.sim.World;

public class GUISampler implements IListener, ISample
{
	private final Object sampler;
	private final double hz;
	
	private long next_sample_time = 0;
	private JLabel label;

	public GUISampler(String group, String lable, Object sampler, double hz)
	{
		this.sampler = sampler;
		this.hz = hz;
		
		label = InputGUI.getBuilder(group).addLabel(lable, "");		
	}

	public void onEvent(Event e)
	{
		if(e.isMsg(World.EVENT_READ))
		{
			read();
		}		
	}

	public void read()
	{
		if(System.currentTimeMillis() > next_sample_time)
		{
			next_sample_time = System.currentTimeMillis() + (long)(1.0/(hz/1000));
			label.setText(sampler.toString());
		}
	}	
}
