package team.app.div;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.List;

import org.jscience.mathematics.vectors.Matrix;

import team.gui.CoordTransform;
import team.gui.Coord;
import team.gui.WorldPainter;

import idb.dom.Node;
import nextgen.utils.uFile;

public class HldPrinter
{
	Node holdeplasser;
	
	CoordTransform utm_world = new CoordTransform(CoordTransform.getUTM2WorldTransform());
	
	public HldPrinter(final WorldPainter view) throws Exception
	{
		holdeplasser = Node.parse(uFile.readString("holdeplasser.txt"));
		view.addMouseListener(new MouseAdapter() {

			public void mouseClicked(MouseEvent e)
			{
				if(e.getButton() == 3)
				{
					
					double dist = 1000;
					Node select = null;
					Coord select_f = null;
					
					Coord pos = view.getWorldCoordFromWindowCoord(e.getX(), e.getY());
					
					List list = holdeplasser.nodes();
				    for(int i = 0; i < list.size(); i++)
				    {
				    	Node hld = (Node) list.get(i);
				    	String utm = hld.nodeText("utm");
				    	
				    	int index = utm.indexOf(',');				    	
				    	double ux = Double.parseDouble(utm.substring(0, index));
				    	double uy = Double.parseDouble(utm.substring(index+1, utm.length()));
				    	
				    	Coord tmp = utm_world.getWorldCoord(ux, uy);
				    	double tdist = pos.distance(tmp);
				    	
				    	if(tdist < dist)
				    	{
				    		dist = tdist;
				    		select = hld;
				    		select_f = tmp;
				    	}
				    }
				    
				    if(select != null)
				    {
				    	String id = select.nodeText("id");
			    		String name = select.nodeText("name");
			    		String wcoord = Math.round(select_f.x) + "," +Math.round(select_f.y);
			    		System.out.println(" hld{id="+id+" tid=2 name=\""+name+"\" wcoord=\""+wcoord+"\"}");
				    }
				}
			}
		});
	}
}
