package team.app.div;

import java.lang.reflect.Method;
import java.text.DecimalFormat;

public class MethodSampler
{
	private Method met;
	private final Object o;
	private final String method;
	
	public MethodSampler(Object o, String method)
	{
		this.o = o;
		this.method = method;
		
		try
		{
			met = o.getClass().getDeclaredMethod(method, new Class[] {});
			met.setAccessible(true);
		} catch (Exception e)
		{
			e.printStackTrace();
			throw new RuntimeException(e);
		}
		
	}
	
	public String getMethod()
	{
		return method;
	}
	
	public Object getReturn()
	{
		try
		{
			Object ret = met.invoke(o, null);
			if(ret instanceof Double)
			{
				double tmp = ((Double)ret).doubleValue();
				DecimalFormat format = new DecimalFormat("###,##0.00");				
				return format.format(tmp);			
			}
			
			return ret;
		} catch (Exception e)
		{
			e.printStackTrace();
			throw new RuntimeException(e);
		}
	}
	
	public String toString()
	{
		return getReturn().toString();
	}
}
