package team.app.div;

import team.sim.Event;
import team.sim.IListener;
import team.sim.World;

public class Printer implements IListener
{
	private final MethodSampler sampler;
	private final double hz;
	
	private long next_sample_time = 0;

	public Printer(Object o, String method, double hz)
	{
		sampler = new MethodSampler(o,method);
		this.hz = hz;
	}

	public void onEvent(Event e)
	{
		if(e.isMsg(World.EVENT_READ) && System.currentTimeMillis() > next_sample_time)
		{
			next_sample_time = System.currentTimeMillis() + (long)(1.0/(hz/1000));
			System.out.println(sampler.getMethod()+"(): " + sampler);
		}		
	}
}
