package team.app.div;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Polygon;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import team.gui.Coord;
import team.gui.IPaint;
import team.gui.WorldPainter;

public class WCoordPainter implements IPaint
{
	private Polygon poly = new Polygon();
	
	public WCoordPainter(final String pre, final WorldPainter view)
	{
		view.addMouseListener(new MouseAdapter(){
			public void mouseClicked(MouseEvent e)
			{				
				Coord pos = view.getWorldCoordFromWindowCoord(e.getX(), e.getY());
				poly.addPoint((int)pos.x, (int)pos.y);
				if(e.getButton() == 3)
					System.out.println(pre + "wcoord=\"" + Math.round(pos.x) + "," + Math.round(pos.y) + "\"");
				
				view.repaint();
			}
		});
	}

	public void paint(Graphics2D g2d)
	{
		if(poly.npoints < 3)
		{
			for(int i = 0; i < poly.npoints; i++)
				g2d.fillOval(poly.xpoints[i]-2, poly.ypoints[i]-2, 4, 4);
			
			return;
		}
		
		g2d.setColor(Color.BLUE);
		g2d.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.5f));
		g2d.fillPolygon(poly);		
	}
}
