package team.app.models;

import sim.DoubleChannel;
import sim.Entity;
import sim.CoordChannel;
import team.app.view.BussPainter.IBuss;
import team.gui.Coord;

public class Bus extends Entity implements IBuss
{
	public DoubleChannel in_delta = new DoubleChannel(this);
	
	public CoordChannel io_position = new CoordChannel(this);
	public DoubleChannel io_req_speed = new DoubleChannel(this);
	public DoubleChannel out_req_move_length = new DoubleChannel(this);
	
	public DoubleChannel out_speed = new DoubleChannel(this);
	public DoubleChannel out_move_length = new DoubleChannel(this);
	
	private Coord old_pos = new Coord(0,0);

	public Bus()
	{
		io_position.initState(new Coord(0,0));
		out_speed.initState(0);
	}
	
	public Coord getPosition()
	{
		return io_position.read();
	}
	
	public double getSpeed()
	{
		return out_speed.read();
	}
	
	public double getMoveLength()
	{
		return out_move_length.read();
	}
	
	protected void read()
	{
		if(getSim().isDebugOn() && false)
			System.out.println("Pos: " + io_position.read() + 
					", req_speed: " + io_req_speed.read() +
					", real_speed: " + out_speed.read());
		
		old_pos.set(io_position.read());
	}

	protected void tick()
	{
		out_move_length.write(io_position.read().distance(io_position.getState()));
		out_speed.write(out_move_length.read() / in_delta.read());
		out_req_move_length.write(io_req_speed.read() * in_delta.read());	
	}
}
