package team.app.models;

import sim.DoubleChannel;
import sim.Entity;
import team.app.div.Random;

public class BusSpeeder extends Entity
{
	public DoubleChannel in_delta = new DoubleChannel(this);
	public DoubleChannel in_time = new DoubleChannel(this);
	
	public DoubleChannel in_length_to_point = new DoubleChannel(this);
	public DoubleChannel in_trafic_at_point = new DoubleChannel(this);
	
	public DoubleChannel in_trafic = new DoubleChannel(this);
	
	public DoubleChannel in_cur_speed = new DoubleChannel(this);
	public DoubleChannel out_req_speed = new DoubleChannel(this);	
	
	//double target_a = 1;
	double _trafic = Random.randn(18,1);
	double trafic = _trafic;
	
	double max_acl = Random.randn(2.5, 0.25);
	double break_acl = Random.randn(-2.5, 0.25);
	
	private double stop_time = -1;
	
	public BusSpeeder()
	{	
	}
	
	public void setStopUntil(double time)
	{		
		if(time > stop_time)
			stop_time = time;
		
		//System.out.println("stop until: " + stop_time);
	}
	
	public void setStopTime(double time)
	{
		setStopUntil(this.in_time.read() + time);
	}
	
	protected void tick()
	{
		if(in_time.read() < stop_time)
		{
			//System.out.println("time: " + in_time.read());
			out_req_speed.write(0);
			return;
		}
		
		double target_speed = 1;
		double a = max_acl;
		
		double[] lengths = in_length_to_point.readAll();
		double[] speeds = in_trafic_at_point.readAll();
		
		double speedsqr = in_cur_speed.read() * in_cur_speed.read();
		
		
		double[] tspeeds = in_trafic.readAll();
		for(int i = 0; i < tspeeds.length; i++)
		{
			target_speed *= tspeeds[i];
		}
		
		target_speed *= trafic;
		
		
		for(int i = 0; i < lengths.length; i++)
		{
			if(lengths[i] <= 0.001)
				continue;
			
			double tmpa = (speeds[i]*speeds[i]*trafic*trafic - speedsqr) / (2 * lengths[i]);
			if(tmpa < break_acl && tmpa+0.1 < a)
			{
				trafic = Random.randn(_trafic,1/2.0);
				target_speed = speeds[i]*trafic;
				a = tmpa+0.1;
			}
		}
		
		double delta = target_speed - in_cur_speed.read();
		
		a = delta;
		if(a > max_acl)
			a = max_acl;
		else if(a < break_acl)
			a = break_acl;
						
			
		
		out_req_speed.write(in_cur_speed.getState() + a * in_delta.read());
		//System.out.println("in: " + in_cur_speed.read() + " out: "+ out_req_speed.read());
	}
}