package team.app.models;

import idb.dom.Node;

import java.awt.Polygon;
import java.util.List;

import sim.DoubleChannel;
import sim.Entity;
import sim.CoordChannel;
import team.app.view.PolyPainter.IPoly;
import team.app.wp.WPUtils;
import team.gui.Coord;

public class Intersection extends Entity implements IPoly
{
	public DoubleChannel in_time = new DoubleChannel(this);
	public CoordChannel in_positions = new CoordChannel(this);
	public DoubleChannel out_speeds = new DoubleChannel(this);
	
	
	private double next = -1;
	private double hold = -1;
	
	private Polygon poly;
	
	public Intersection(Node k)
	{
		poly = new Polygon();
		List cs = k.selectAll("wcoord");
		for(int i = 0; i < cs.size(); i++)
		{
			Node n = (Node) cs.get(i);
			Coord c = WPUtils.parseWCoord(n.text());
			poly.addPoint((int)c.x, (int)c.y);
		}
		
		next = in_time.read() + 2 * 60;
	}
	
	public Polygon getPolygon()
	{
		return poly;
	}
	
	public void tick()
	{		
		if(in_time.read() > next)
		{
			hold = in_time.read() + 0.5 * 60;
			next = hold + 0.5 * 60;			
		}
		
		out_speeds.write(1);
		
		Coord[] coords = in_positions.readAll();
		for(int i = 0; i < coords.length; i++)
		{
			Coord c = coords[i];
			if(poly.contains(c.x,c.y))
			{
				if(in_time.read() < hold)
					out_speeds.write(0, i);
				else
					out_speeds.write(0.5,i);
			}
		}
	}	
}
