package team.app.models;

import sim.CoordChannel;
import sim.DoubleChannel;
import sim.Entity;
import team.app.div.Random;
import team.gui.Coord;

public class PositioningTech extends Entity
{
	public DoubleChannel in_time = new DoubleChannel(this);
	public CoordChannel in_pos = new CoordChannel(this);
	public CoordChannel out_pos = new CoordChannel(this);
	
	private double next_time;
	private final double interval;
	private final double dev;
	
	public PositioningTech(double interval, double std_deviation)
	{
		this.interval = interval;
		this.dev = std_deviation;
		next_time = in_time.read() + interval;
	}
	
	public void tick()
	{
		if(in_time.read() > next_time)
		{
			next_time = in_time.read() + interval;
			Coord tmp = in_pos.read().copy();
			if(dev > 0.1)
			{
				tmp.x = Random.randn(tmp.x, dev);
				tmp.y = Random.randn(tmp.y, dev);
			}
			out_pos.write(tmp);
		}		
	}
}
