package team.app.models;

import sim.CoordChannel;
import sim.DoubleChannel;
import sim.Entity;
import team.app.system.Register;

public class RegisterSampler extends Entity
{
	public DoubleChannel in_total_time = new DoubleChannel(this);
	public CoordChannel in = new CoordChannel(this);

	private Register reg;
	private int bussID;
	private int techID;
	private boolean aktive = false;
	
	public RegisterSampler(Register reg, int bussID, int techID)
	{
		this.reg = reg;
		this.bussID = bussID;
		this.techID = techID;
	}
	
	protected void rollback()
	{
		aktive = false;
		super.rollback();
	}
	
	public void tick()
	{
		if(in.isActive())
		{
			aktive = true;
			in.read();
		}
		else
			aktive = false;
	}
	
	public void post_tick()
	{
		if(aktive)
			reg.regObs(in_total_time.read(), bussID, in.read(), techID);
	}
}
