package team.app.models;

import sim.BooleanChannel;
import sim.Entity;
import team.app.div.ITime;
import team.sim.models.Time;

public class RouteTimer extends Entity
{	
	public BooleanChannel in_trip_finsihed = new BooleanChannel(this);
	
	private final Schedule sch;
	private final ITime time;

	public RouteTimer(ITime time, Schedule sch, RouteDriver driver)
	{
		this.time = time;
		this.sch = sch;
		
		in_trip_finsihed.initState(false);
		in_trip_finsihed.connect(driver.out_event_finished);
	}
	
	public static String cap(String s, int length, boolean align_right)
	{
		if(s.length() >= length)
			return s.substring(0, length);
		
		StringBuffer b = new StringBuffer(s);
		while(b.length() < length)
		{
			if(align_right)
				b.insert(0, ' ');
			else
				b.append(' ');
		}
		
		return b.toString();
	}
	
	protected void read()
	{
		if(in_trip_finsihed.read())
			System.out.println("TripID: "+cap(sch.getScheduleID(),2,true)+", rute: " + cap(sch.getRouteID(),7,false)
				+ " ferdig,  start: " + Time.format(sch.getRouteStartTime()) + ", slutt: " + Time.format(time.getSimTime())
				+ "   reisetid: " + Time.format(time.getSimTime() - sch.getRouteStartTime()) + ", ventetid: " 
				+ Time.format(sch.getNextRouteStartTime() - time.getSimTime()));
	}

	protected void tick()
	{
		
		
	}
}
