package team.app.models;

import java.util.List;

import sim.DoubleChannel;
import sim.Entity;
import team.app.IConfig;
import team.app.system.loader.ScheduleData;
import team.app.system.loader.TableScheduleFilterLoader;

public class ScheduleAvgSpeedCalc extends Entity
{
	public DoubleChannel out_speed = new DoubleChannel(this);
	
	private final IConfig conf;
	private final Schedule schedule;
	private final RouteStop stops;
	
	private List leg_data;
	private int index = 0;
	
	private double avg_speed = 15;
	
	private boolean tmp_next_route;

	public ScheduleAvgSpeedCalc(IConfig conf, Schedule schedule, RouteStop stops)
	{
		this.conf = conf;
		this.schedule = schedule;
		this.stops = stops;
		
	}
	
	public void setRoute(String rid)
	{
		leg_data = new TableScheduleFilterLoader(conf).loadRouteData(rid, 0, 0);		
	}
	
	public void reset()
	{
		setRoute(schedule.getRouteID());
		
		index = 0;
		ScheduleData d = (ScheduleData) leg_data.get(index++);
		avg_speed = d.leg_speed;
		//System.out.println("Next: " + d.name + ", speed: " + avg_speed);
	}
	
	public void read()
	{
		tmp_next_route = false;
		
		if(schedule.eventNextRoute())
			tmp_next_route = true;
		
		if(stops.eventNextStop() && index < leg_data.size())
		{
			ScheduleData d = (ScheduleData) leg_data.get(index++);
			avg_speed = d.leg_speed;
			//System.out.println("Next: " + d.name + ", speed: " + avg_speed);
		}
	}
	
	public void write()
	{
		if(tmp_next_route)
			reset();
	}
	
	public void tick()
	{
		out_speed.write(avg_speed);
	}
}
