package team.app.models;

import idb.dom.Node;

import java.util.ArrayList;
import java.util.List;

import sim.Constant;
import sim.Sim;
import sim.Time;
import sim.test2.Logger;
import team.app.App;
import team.app.div.GUISampler;
import team.app.div.HldDrawer;
import team.app.div.HldPrinter;
import team.app.div.MethodSampler;
import team.app.div.Random;
import team.app.div.TimeViewer;
import team.app.div.WCoordPrinter;
import team.app.system.DB;
import team.app.system.Register;
import team.app.view.ModelPainter;
import team.app.view.PolyPainter;
import team.app.view.StopPainter;
import team.gui.Animator;
import team.gui.Coord;
import team.gui.InputGUI;

public class Test
{	
	public static void loadRoutes(App app, Sim sim, Time time, Register reg)
	{
		Logger log = new Logger();
		log.setMod(10);
		log.setLogXValuebigger(Time.toDouble(6, 4, 55));
		log.connect(time.out_time);
			
		
		Node rute = app.getConfig("rute.txt");
		
		List kryss = new ArrayList();
		List nkryss = rute.selectAll("kryss/kryss");
		for(int i = 0; i < nkryss.size(); i++)
		{
			Intersection k = new Intersection((Node) nkryss.get(i));
			new PolyPainter(app, k);
			kryss.add(k);
		}
		
		List trafic = new ArrayList();
		List ntrafic = rute.selectAll("omrder/omrde");
		for(int i = 0; i < ntrafic.size(); i++)
		{
			Area t = new Area((Node) ntrafic.get(i));
			new PolyPainter(app, t);
			trafic.add(t);
		}
		
		
		List busser = rute.selectAll("busser/buss");
		for(int i = 0; i < busser.size(); i++)
		{
			final Bus bus = new Bus();
			final RouteDriver bus_driver = new RouteDriver();
			final Schedule schedule = new Schedule(bus_driver, app);
			final BusSpeeder bus_speeder = new BusSpeeder();
			final RouteStop route_stop = new RouteStop(app,bus_driver,bus_speeder,schedule);
			final RouteCurves route_curves = new RouteCurves(app,schedule);
			
			final RouteTimer rout_timer = new RouteTimer(time,schedule,bus_driver);			
			final ScheduleDelayCalc sch_delay_calc = new ScheduleDelayCalc(app,schedule);
			
			
			final PositioningTech real = new PositioningTech(1,0);
			final PositioningTech gps = new PositioningTech(1,10/2);
			final PositioningTech mobile = new PositioningTech(10,500/2);
			
			final RegisterSampler rreal = new RegisterSampler(reg,i,0);
			final RegisterSampler rgps = new RegisterSampler(reg,i,1);
			final RegisterSampler rmob = new RegisterSampler(reg,i,2);
			final RegisterSampler rstop = new RegisterSampler(reg,i,3);
			
			Node buss = (Node) busser.get(i);
			
			List bruter = buss.selectAll("trips/*");
			for(int j = 0; j < bruter.size(); j++)
			{
				Node brute = (Node) bruter.get(j);
				Node trip = rute.select("trips/trip[id='"+brute.name()+"']");
				String tid = trip.nodeText("tid");				
				schedule.loadTrip(trip.nodeText("id"), trip.nodeText("rid"), Time.toDouble(tid));
			}
			
			reg.regActiveSchedule(time.getTotalTime(), i, schedule.getTripIDs());
			
			//if(i == 0)
				log.connect(bus.out_speed, "Speed bus: " + i);
			
			bus.io_position.connect(bus_driver.out_position);
			bus.io_req_speed.connect(bus_speeder.out_req_speed);
			
			bus_driver.in_move_length.connect(bus.out_req_move_length);
			
			route_stop.in_move_length.connect(bus.out_move_length);
			
			sch_delay_calc.in_pos.connect(bus.io_position);
			
			route_curves.in_dist_route_end.connect(bus_driver.out_length_to_end);
			
			bus_speeder.in_cur_speed.connect(bus.out_speed);
			
			bus_speeder.in_length_to_point.connect(route_stop.out_length_to_stop);
			bus_speeder.in_trafic_at_point.connect(new Constant(0));
			
			bus_speeder.in_length_to_point.connect(route_curves.out_length_to_curve);
			bus_speeder.in_trafic_at_point.connect(route_curves.out_curve_speed);
			
			bus_speeder.in_length_to_point.connect(route_curves.out_length_to_curve2);
			bus_speeder.in_trafic_at_point.connect(route_curves.out_curve_speed2);			
			
			bus_speeder.in_trafic.connect(new Constant(1));
			
			gps.in_pos.connect(bus.io_position);
			mobile.in_pos.connect(bus.io_position);
			real.in_pos.connect(bus.io_position);
			
			rgps.in.connect(gps.out_pos);
			rmob.in.connect(mobile.out_pos);	
			rreal.in.connect(real.out_pos);
			rstop.in.connect(route_stop.out_next_stop);
			
			for(int j = 0; j < kryss.size(); j++)
			{
				Intersection k = (Intersection) kryss.get(j);
				k.in_positions.connect(bus.io_position);
				k.in_positions.setMargin(5);
				bus_speeder.in_trafic.connect(new Buffer(k.out_speeds));
			}
			
			for(int j = 0; j < trafic.size(); j++)
			{
				Area t = (Area) trafic.get(j);
				t.in_positions.connect(bus.io_position);
				t.in_positions.setMargin(5);
				bus_speeder.in_trafic.connect(new Buffer(t.out_trafic));
			}
			
			
			ModelPainter busp = new ModelPainter(app,"buss.GIF");
			busp.setScale(0.5);
			busp.setSource(bus.io_position);
			
			ModelPainter delayp2 = new ModelPainter(app,"spm.GIF");
			delayp2.setSource(new ModelPainter.IPos() {
				public Coord getPosition()
				{
					return sch_delay_calc.getEstimatePosition();
				}});
			
			ModelPainter delayp = new ModelPainter(app,"point.GIF");
			delayp.setSource(new ModelPainter.IPos() {
				public Coord getPosition()
				{
					return sch_delay_calc.getScheduledPosition();
				}});
			
			ModelPainter gpsp = new ModelPainter(app,"gps.GIF");
			gpsp.setSource(gps.out_pos);
			
			ModelPainter mobilep = new ModelPainter(app,"gps.GIF");
			mobilep.setSource(mobile.out_pos);
			mobilep.setScale(2);
			

			new StopPainter(app, route_stop);
			
			sim.regSampler(new GUISampler("Buss: " + i,"getMoveLength()",new MethodSampler(bus,"getMoveLength"),10));
			sim.regSampler(new GUISampler("Buss: " + i,"getScheduledProgress()",new MethodSampler(sch_delay_calc,"getScheduleLength"),10));
			sim.regSampler(new GUISampler("Buss: " + i,"getNextcurveSpeed()",new MethodSampler(route_curves,"getNextSpeed"),10));
			sim.regSampler(new GUISampler("Buss: " + i,"getNextcurveLength()",new MethodSampler(route_curves,"getLength"),10));
			sim.regSampler(new GUISampler("Buss: " + i,"getNextStopLength()",new MethodSampler(route_stop,"getNextStopLength"),10));
			
			
			//sim.regSampler(new GUISampler("Buss: " + i,"length_to_stop",new PropSampler(stops,"length_to_stop"),1));
		}
		
		log.toPlot();
	}
	
	
	public static void main(String[] args) throws Exception
	{
		//Random.random = false;
		Random.setTimeSeed();
		//DoubleChannel.MARGIN = 0.0001;
		//CoordChannel.MARGIN = 0.0001;
		
		Register reg = new Register();
		DB db = new DB(reg);
		//db.load("log.txt");
		
		App app = new App();
		app.loadMaps();
		
		Node maps = app.getConfig("arg.txt");
		if(maps.nodeText("holdeplasser") != null && maps.nodeText("holdeplasser").equals("true"))
			new HldDrawer(app.shape_p);
		
		new HldPrinter(app.world_p);
		new WCoordPrinter(app.world_p);
		
		Sim sim = new Sim();		
		//Dag opdatert.. bare kjr
		Time time = new Time(Time.toDouble(6, 4, 0),6);
		time.setStopTime(Time.toDouble(10, 0, 0));
		time.io_delta.connect(new Constant(0.1));
		
		sim.autoConnect(time.io_delta);
		sim.autoConnect(time.out_time);
		sim.autoConnect(time.out_total_time);
		
		sim.regSampler(new Animator(app.world_p).setTime(time).regControls(InputGUI.getBuilder()));
		sim.regSampler(new TimeViewer(time));
		
		loadRoutes(app, sim, time, reg);
		
		//sim.setDebug(true);
		sim.setDebugMod(1000);
		sim.setDebugLevel(0);
		
		app.show();
		sim.play(50);
		
		//db.save("log.txt");
		System.out.println("Ferdig");
	}
}
