package team.app.system.filter;

import team.app.delay.Filter;
import team.app.system.ScheduleCalc;
import team.app.system.ScheduleReg;
import team.gui.Coord;

public class AvgFilter implements IPosFilter
{
	private int size = 0;
	private double[] data = new double[10000];
	private double[] fdata;
	private double fsize;
	
	public AvgFilter(double fsize)
	{
		this.fsize = fsize;		
	}
	
	public Coord filter(double time, Coord pos, ScheduleReg reg)
	{
		ScheduleCalc c = reg.getCalc();
		double messured_adherence = DiffAvgFilter.calcAdherence(time, pos, c);
		
		data[size++] = messured_adherence;
		fdata = Filter.filter(Filter.createAvg(fsize), data, size);
		
		System.out.println(messured_adherence);
		return c.getScheduledPosition(time + fdata[size-1]);
	}

	public void setRoute(String id)
	{
		size = 0;
	}
}
