package team.app.system.filter;

import team.app.delay.Kalman2;
import team.app.system.ScheduleCalc;
import team.app.system.ScheduleReg;
import team.gui.Coord;

public class KalmanFilter implements IPosFilter
{
	Kalman2 kalman = new Kalman2();

	public Coord filter(double time, Coord pos, ScheduleReg reg)
	{		
		ScheduleCalc c = reg.getCalc();
		double ad = DiffAvgFilter.calcAdherence(time, pos, c);
		
		kalman.reg(ad, 0.2);
		//System.out.println("justering: " + (kalman.estimatePos() - ad));
		
		return c.getScheduledPosition(kalman.estimatePos()+time);
	}

	public void setRoute(String id)
	{
		kalman.set(0, 0);
	}

}
