package team.app.system.filter;

import team.app.system.ScheduleCalc;
import team.app.system.ScheduleReg;
import team.app.system.stat.LSStat;
import team.gui.Coord;

public class LSFilter implements IPosFilter
{
	LSStat stat = new LSStat();

	public Coord filter(double time, Coord pos, ScheduleReg reg)
	{
		ScheduleCalc c = reg.getCalc();
		double ad = DiffAvgFilter.calcAdherence(time, pos, c);		
		double elength = c.getScheduleLength(time+ad);
		
		stat.reg(elength, ad);
		stat.calcLeastSquaresMod();
		//System.out.println("delay: " + stat.estimateTime(elength));
		return c.getScheduledPosition(stat.estimateTime(elength)+time);
	}

	public void setRoute(String id)
	{
		stat.clear();
	}
}
