package team.app.system.loader;

import java.util.List;

import team.app.IConfig;

public class TableScheduleFilterLoader implements IScehduleLoader
{
	private final IConfig config;


	public TableScheduleFilterLoader(IConfig config)
	{
		this.config = config;
	}
	

	public List loadRouteData(String routeID, int tripID, double time)
	{
		TableScheduleLoader l = new TableScheduleLoader(config);
		List data = l.loadRouteData(routeID, 0, 0);
		
		for(int i = 0; i < data.size(); i++)
		{
			ScheduleData d = (ScheduleData) data.get(i);
			
			double al = 0;
			double at = 0;
			//double av = 0;
			
			for(int j = 0; j < data.size(); j++)
			{
				ScheduleData f = (ScheduleData) data.get(j);
				double v = getScale(j-i);
				
				al += v*(f.leg_length);
				at += v*(f.leg_time*60 - l.getHldTime());
				//av += v;
			}
			
			d.leg_speed = al/at;
		}		
		return data;		
	}
	
	public static double getScale(int index)
	{
		index = Math.abs(index);
		double filter_size = 4;
		int ifilter_size = (int)filter_size;
		
		if(index == 0)
			return 1;		
		else if(index < ifilter_size)
			return 1;
		else if(index == ifilter_size)
			return filter_size - ifilter_size;
		else
			return 0;		
	}

}
