package team.app.system.loader;

import java.util.ArrayList;
import java.util.List;

import team.app.IConfig;
import team.app.system.stat.History;
import team.app.system.stat.TripStat;
import team.app.wp.WPUtils;

public class TripStatLoader implements IScehduleLoader
{
	private String stat_file;
	private IConfig conf;
	
	public TripStatLoader(IConfig conf, String stat_file)
	{
		this.conf = conf;
		this.stat_file = stat_file;	
	}

	public List loadRouteData(String routeID, int tripID, double time)
	{
		List data_list = new ArrayList();
		TripStat stat = new TripStat(new History(stat_file));
		//stat.load(stat_file);
		
		double dx = 20;
		double length = WPUtils.getRouteLengthExEnds(routeID, conf);
		
		double x = 0;
		while(true)
		{
			if(x > length)
				x = length+0.001;
			
			ScheduleData data = new ScheduleData();
			data_list.add(data);
			
			data.acu_length = x;
			data.leg_length = dx;
			
			
			data.sch_time = stat.estimateTime(x/length, tripID);
			data.leg_time = data.sch_time - stat.estimateTime((x-dx)/length, tripID);
			data.leg_speed = data.leg_length / data.leg_time;
			
			if(x > length)
				break;
			
			x+= dx;
		}
		
		
		return data_list;
	}

}
