package team.app.system.stat;

public class RouteStat
{
	private final History data;

	public RouteStat(History data)
	{
		this.data = data;		
	}
	
	public double estimateTime(double nlength, String ruteID)
	{
		double value = 0;
		double weights = 0;
		
		for(int i = 0; i < data.size(); i++)
		{
			TripData d = (TripData) data.get(i);
			if(!d.ruteID.equals(ruteID))
				continue;
			
			value += d.interpolateTime(d.length*nlength);
			weights += 1;
		}
		
		return value/weights;
	}
	
	public double estimateLength(double time, String ruteID)
	{
		double value = 0;
		double weights = 0;
		
		for(int i = 0; i < data.size(); i++)
		{
			TripData d = (TripData) data.get(i);
			if(!d.ruteID.equals(ruteID))
				continue;
			
			value += d.interpolateLength(time);
			weights += 1;
		}
		
		return value/weights;
	}
}
