/**
 * 
 */
package team.app.system.stat;

import team.app.system.ScheduleCalc;

class TripData
{
	public int tripID;
	public String ruteID;
	public int month;
	public int weekDay;
	public double time;
	public double length;
	
	public int size = 0;
	public double[] y = new double[10000];
	public double[] x = new double[10000];
	
	public void reg(double length, double time)
	{	
		//System.out.println("length: " + length + ", time: " + time);
		
		if(length < 0.01)
			return;
		
		y[size] = time;
		x[size] = length;
		size++;
	}
	
	public double interpolateTime(double length)
	{
		if(length < x[0])
			return y[0];
		else if(length > x[size-1])
			return y[size-1];
		
		for(int i = 0; i < size-1; i++)
		{
			if(x[i] <= length && length < x[i+1])
				return ScheduleCalc.interpolate(y[i], y[i+1], ScheduleCalc.ratio(x[i],x[i+1], length));
			//else if(x[i+1] < length && length <= x[i])
			//	return ScheduleDelay.interpolate(y[i+1], y[i], ScheduleDelay.ratio(x[i+1],x[i], length));
		}
		
		return -1;
	}
	
	public double interpolateLength(double time)
	{
		if(time < y[0])
			return x[0];
		else if(time > y[size-1])
			return x[size-1];
		
		for(int i = 0; i < size-1; i++)
		{
			if(y[i] < time && time <= y[i+1])
				return ScheduleCalc.interpolate(x[i], x[i+1], ScheduleCalc.ratio(y[i],y[i+1], time));
			//else if(x[i+1] < length && length <= x[i])
			//	return ScheduleDelay.interpolate(y[i+1], y[i], ScheduleDelay.ratio(x[i+1],x[i], length));
		}
		
		return -1;
	}
}