package team.app.system.stat;


public class TripStat
{
	private final History data;

	public TripStat(History data)
	{
		this.data = data;
	}
	
	public double estimateTime(double nlength, int tripID)
	{
		double value = 0;
		double weights = 0;
		
		for(int i = 0; i < data.size(); i++)
		{
			TripData d = data.get(i);
			if(d.tripID != tripID)
				continue;
			
			value += d.interpolateTime(d.length*nlength);
			weights += 1;
		}
		
		return value/weights;
	}
	
	public double estimateLength(double time, int tripID)
	{
		double value = 0;
		double weights = 0;
		
		for(int i = 0; i < data.size(); i++)
		{
			TripData d = data.get(i);
			if(d.tripID != tripID)
				continue;
			
			value += d.interpolateLength(time);
			weights += 1;
		}
		
		return value/weights;
	}
}
