package team.app.view;

import java.awt.Graphics2D;
import java.awt.Image;

import team.app.App;
import team.gui.Coord;
import team.gui.IPaint;

public class BussPainter implements IPaint
{
	private Image image_buss;
	private final IBuss buss;
	private final App app;

	public BussPainter(App app, IBuss buss)
	{
		this.app = app;
		this.buss = buss;
		image_buss = app.loadImage("res/buss.GIF");
		app.shape_p.registerPainter(this);		
	}

	public void paint(Graphics2D g2d)
	{
		Coord pos = buss.getPosition();		
		
		app.shape_p.setNoScale(g2d, pos.x, pos.y);
		g2d.scale(0.5, 0.5);
		g2d.translate(-image_buss.getWidth(null)/2, -image_buss.getHeight(null)/2);
		g2d.drawImage(image_buss, 0, 0, null);
	}
	
	public static interface IBuss
	{
		public Coord getPosition();
	}
}
