package team.app.view;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Composite;
import java.awt.Graphics2D;
import java.awt.Polygon;

import team.app.App;
import team.app.models.Intersection;
import team.gui.IPaint;

public class PolyPainter implements IPaint
{
	private final IPoly poly;
	private final App app;
	
	private Color c = new Color(100,100,255);

	public PolyPainter(App app, IPoly poly)
	{
		this.app = app;
		this.poly = poly;
		
		app.shape_p.registerPainter(this);		
	}

	public void paint(Graphics2D g2d)
	{
		Color org = g2d.getColor();
		Composite org_c = g2d.getComposite();
		
		g2d.setColor(c);
		g2d.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.5f));
		g2d.fillPolygon(poly.getPolygon());
		
		g2d.setColor(org);
		g2d.setComposite(org_c);
	}
	
	public static interface IPoly
	{
		public Polygon getPolygon();
	}
}
