package team.app.view;

import java.awt.Graphics2D;

import team.app.App;
import team.gui.Coord;
import team.gui.IPaint;

public class StopPainter implements IPaint
{
	private final IStops stops;
	private final App app;

	public StopPainter(App app, IStops stops)
	{
		this.app = app;
		this.stops = stops;
		
		app.shape_p.registerPainter(this);
	}

	public void paint(Graphics2D g2d)
	{		
		Coord coord = stops.getNextStopCoord();
		if(coord == null)
			return;
		
		app.shape_p.setNoScale(g2d, coord.x, coord.y);
		g2d.fillRect(-5, -5, 10, 10);
	}
	
	public static interface IStops
	{
		public Coord getNextStopCoord();
	}

}
