package team.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JPanel;
import javax.swing.JTextField;

import sim.ISample;
import team.app.div.ITime;
import team.sim.Event;
import team.sim.IListener;
import team.sim.World;

public class Animator implements IListener, ISample
{
	private boolean run = false;
	private final JPanel panel;
	private int count = 1;
	
	private double fast_forward = 0;
	
	private int ticks_pr_snapshot = 1;
	private int delay = 100;
	
	private double acc_time = 1;
	
	private ITime time;
	
	public Animator(JPanel panel)
	{
		this.panel = panel;
	}
	
	public Animator setTime(ITime time)
	{
		this.time = time;
		return this;
	}
	
	public void start()
	{
		run = true;
		
		new Thread(new Runnable() {
			public void run()
			{
				while(run)
				{
					animate();
				}
			}}).start();
	}
	
	public void stop()
	{
		run = false;
	}
	
	public void animate()
	{
		panel.repaint();
		try
		{
			if(delay > 5)
				Thread.sleep(delay);
		} catch (Exception e)
		{
		}		
	}
	
	public Animator regControls(InputGUI gui)
	{		
		final JTextField delay = gui.addTextField("Delay", String.valueOf(this.delay));
		delay.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e)
			{
				try
				{
					setDelay(Integer.parseInt(delay.getText()));
				} catch (Exception ex)
				{
					ex.printStackTrace();
				}
				
			}});
		
		final JTextField acc = gui.addTextField("Time acc", String.valueOf(getSimtimeFactor()));
		acc.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e)
			{
				try
				{
					setSimtimeFactor(Double.parseDouble(acc.getText()));
				} catch (Exception ex)
				{
					ex.printStackTrace();
				}
				
			}});
		
		return this;
	}
	
	public void setSimtimeFactor(double factor)
	{
		if(factor < 0.00000001)
			return;
		
		acc_time = factor;
	}
	
	public double getSimtimeFactor()
	{		
		return acc_time;
	}
	
	public void setDelay(int value)
	{
		delay = value;
		System.out.println("Delay: " + delay);
	}
	
	public Animator fastForward(double time)
	{
		fast_forward = time;
		return this;
	}
	
	public void read()
	{
		int tmp = (int)Math.round(1/time.getDeltaTime() * acc_time); // * (double)delay / 1000.0);
		
		if(tmp == 0)
			tmp = 1;
		
		if(time.getSimTime() > fast_forward && count++ % tmp == 0)
			animate();
	}

	public void onEvent(Event e)
	{		
		if(e.isMsg(World.EVENT_READ))
		{
			read();
		}
	}
	
}
