/**
 * 
 */
package team.gui;

import org.jscience.mathematics.numbers.Float64;
import org.jscience.mathematics.numbers.Number;
import org.jscience.mathematics.structures.Field;
import org.jscience.mathematics.vectors.Vector;

public class Coord
{
	public double x;
	public double y;
	
	public Coord(double x, double y)
	{
		this.x = x;
		this.y = y;
	}
	
	public Coord(Coord c)
	{
		set(c);
	}
	
	public Coord(Vector v)
	{
		x = ((Float64)v.get(0)).doubleValue();
		y = ((Float64)v.get(1)).doubleValue();
	}
	
	public void set(Coord pos)
	{
		x = pos.x;
		y = pos.y;
	}
	
	public String toString()
	{
		return "x: "+x+", y: " + y;
	}
	
	public Vector toVector()
	{
		return Vector.valueOf(new double[] {x,y,1});
	}
	
	public double distance(Coord pos)
	{
		double a = pos.x - x;
		double b = pos.y - y;
		
		a *= a; b *= b;
		
		return Math.sqrt(a+b);
	}
	
	public static double length(Vector v)
	{
		double ret = 0;
		for(int i = 0; i < v.getDimension(); i++)
		{
			Number n = (Number)v.get(i);
			ret += n.doubleValue() * n.doubleValue();
			
		}
		return Math.sqrt(ret);
	}
	
	public Coord copy()
	{
		return new Coord(this);
	}
}