package team.gui;

import java.awt.Graphics2D;
import java.awt.Image;
import java.io.File;
import java.net.URL;

import javax.imageio.ImageIO;

public class ImageComp
{
	private Image image;
	
	public ImageComp(String file)
	{
		image = loadImage(file);
	}
	
	public ImageComp(URL url)
	{
		image = loadImage(url);
	}
	
	public void draw(Graphics2D g)
	{
		g.drawImage(image, 0, 0, null);
	}
	
	public Image getImage()
	{
		return image;
	}
	
	public static Image loadImage(String file)
	{
		try
		{
			return loadImage(new File(file).toURL());
		} catch (Exception e)
		{
			e.printStackTrace();
			throw new RuntimeException(e);
		}
	}
	
	public static Image loadImage(URL url)
	{
		try
		{				
			return ImageIO.read(url);
			
		} catch (Exception e)
		{
			e.printStackTrace();
			throw new RuntimeException(e);
		}
	}
}