package team.gui;

import java.awt.Component;
import java.awt.Container;
import java.util.HashMap;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.Border;

import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import com.jgoodies.forms.layout.RowSpec;

public class InputGUI
{
	private static JFrame frame;
	private static Builder fbuilder;
	
	private static HashMap map = new HashMap();
	
	private Builder builder;
	
	private static void createFrame()
	{
		frame = new JFrame("Controls");
		frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		fbuilder = new Builder("p",frame.getContentPane());
	}
	
	public InputGUI(Builder builder)
	{
		this.builder = builder;
	}
	
	public static InputGUI getBuilder(String type)
	{		
		if(frame == null)
			createFrame();
		
		if(map.get(type) == null)
		{
			JPanel panel = new JPanel();
			
			Border border = BorderFactory.createEmptyBorder(5, 8, 3, 5);
			border = BorderFactory.createCompoundBorder(border, BorderFactory.createTitledBorder(type));
			border = BorderFactory.createCompoundBorder(border, BorderFactory.createEmptyBorder(0, 5, 2, 5));
			
			panel.setBorder(border);
			fbuilder.add(panel).newLine();
			
			map.put(type, new InputGUI(new Builder("p,5dlu,50dlu",panel)));
		}
		
		return (InputGUI) map.get(type);		
	}
	
	private static class Builder
	{
		private FormLayout layout;
		private CellConstraints c = new CellConstraints();
		private Container container;
		private int x = 1;
		private int y = 1-2;
		private boolean nl = false;
		
		public Builder(Container c)
		{
			this("p,4dlu,p",c);
		}
		
		public Builder(String colspec, Container c)
		{
			container = c;
			layout = new FormLayout(colspec);
			container.setLayout(layout);
			newLine();
		}
		
		public Builder add(Component comp)
		{
			if(nl)
				_newLine();
			
			container.add(comp, c.xy(x, y));
			x+=2;
			return this;
		}
		
		private void _newLine()
		{
			layout.appendRow(new RowSpec("p"));
			layout.appendRow(new RowSpec("4dlu"));
			y+=2;
			x=1;
			nl = false;
		}
		
		public Builder newLine()
		{
			nl = true;
			return this;
		}
	}
	
	public static InputGUI getBuilder()
	{		
		return getBuilder("Main controls");
	}
	
	public JButton addButton(String label, String tekst)
	{
		JButton b = new JButton(tekst);
		builder.add(new JLabel(label)).add(b).newLine();
		frame.pack();
		return b;
	}
	
	public JButton addButton(String tekst)
	{
		JButton b = new JButton(tekst);
		builder.add(new JLabel("Command")).add(b).newLine();
		frame.pack();
		return b;
	}
	
	public JLabel addLabel(String label, String tekst)
	{
		JLabel b = new JLabel(tekst);
		builder.add(new JLabel(label)).add(b).newLine();
		frame.pack();
		return b;
	}
	
	public JTextField addTextField(String label, String tekst)
	{
		JTextField b = new JTextField(tekst);
		builder.add(new JLabel(label)).add(b).newLine();
		frame.pack();
		return b;
	}
	
	public static void setVisible(boolean visible)
	{
		frame.pack();
		frame.setVisible(visible);
	}
}
