package team.sim;

import java.util.ArrayList;

public class Dispatcher
{
	private static int free_msg_id = 1;
	
	private ArrayList list = new ArrayList();
	private Event e = new Event();
	
	public Dispatcher(Object source)
	{
		e.setSource(source);
	}
	
	public void fireEvent(int event_id)
	{
		e.setMsg(event_id);
		for(int i = 0; i < list.size(); i++)
		{
			IListener l = (IListener) list.get(i);
			l.onEvent(e);
		}
	}
	
	public void addListener(IListener listener)
	{
		list.add(listener);
	}
	
	public void removeListener(IListener listener)
	{
		list.remove(listener);
	}	
	
	public static int getEventID(String msg)
	{
		return free_msg_id++;
	}
}
