package team.sim.models;

import team.sim.Event;
import team.sim.IListener;
import team.sim.World;

public class CarbonDating implements IListener
{
	private float mass = 3;	
	private float new_mass = mass;
	private float k = -0.1f;
	
	private Time time;
	
	public CarbonDating(World world)
	{
		time = Time.getTime(world);		
	}
	
	public static CarbonDating findInst(World w)
	{
		return (CarbonDating) w.findInstanceOf(CarbonDating.class);
	}
	
	public float getMass()
	{
		return mass;
	}

	public void onEvent(Event e)
	{
		if(e.isMsg(World.EVENT_RESET))
		{
			mass = 3;
			new_mass = mass;
		}		
		if(e.isMsg(World.EVENT_READ))
		{
			new_mass += k * mass * time.getDeltaTime();;
		}
		if(e.isMsg(World.EVENT_TICK))
		{
			mass = new_mass;
			if(time.tickCount() % 10 == 0)
				System.out.println("Time: " + time.getSimTime() + ", Mass: " + mass);
		}
	}
}
