package team.sim.models;

import java.util.ArrayList;
import java.util.List;

import backup.div.Excel;

import team.sim.Event;
import team.sim.IListener;
import team.sim.World;

public class Logger implements IListener
{
	private Time time;
	private CarbonDating carb;
	private final World world;
	
	private List time_list = new ArrayList();
	private List data_list = new ArrayList();;
	
	public Logger(World w)
	{
		this.world = w;		
	}
	
	public void onEvent(Event e)
	{
		if(e.isMsg(World.EVENT_RESET))
		{
			time = Time.getTime(world);
			carb = CarbonDating.findInst(world);
			
			time_list.clear();
			data_list.clear();
		}
		else if(e.isMsg(World.EVENT_READ))
		{
			time_list.add(String.valueOf(time.getSimTime()).replace('.', ','));
			data_list.add(String.valueOf(carb.getMass()).replace('.', ','));
		}
		else if(e.isMsg(World.EVENT_DONE))
		{
			try
			{
				Excel ex = new Excel();
				ex.newBook();
				ex.write(time_list, "A", 2);
				ex.write(data_list, "B", 2);
				ex.quit();
			} catch (Exception ex)
			{
				ex.printStackTrace();
			}
			
			
			
		}
	}
}
