package team.sim.models;

import team.app.div.ITime;
import team.sim.Dispatcher;
import team.sim.Event;
import team.sim.IListener;
import team.sim.World;

public class Time implements IListener, ITime
{	
	private float time = 0;
	private float delta_time = 0.1f;
	private float stop_time = -1;
	
	private int tcount = 0;
	public Dispatcher notifier = new Dispatcher(this);
	
	public Time()
	{
		
	}
	
	public Time(float time)
	{
		this.time = time;
	}
	
	public static Time getTime(World w)
	{
		Time time = (Time) w.findInstanceOf(Time.class);
		if(time == null)
			throw new RuntimeException("Kan ikke finne tidsklasse: Time");
		
		return time;
	}
	
	public void setMaxDelta(Object source, float delta)
	{
		delta_time = delta;
	}
	
	public int tickCount()
	{
		return tcount;
	}
	
	public float getDeltaTime()
	{
		return delta_time;
	}
	
	public float getSimTime()
	{
		return time;
	}
	
	public void setStopTime(float time)
	{
		stop_time = time;
	}
	
	public static String format(double time)
	{
		boolean neg = false;
		if(time < 0)
		{
			neg = true;
			time = -time;
		}
			
		
		double tmp = time / 60 /60;
		int hr = (int) tmp;
		tmp = tmp - hr;
		tmp *= 60;
		int min = (int) tmp;
		tmp = tmp - min;
		tmp *= 60;
		int sek = (int)Math.round(tmp);
		
		StringBuilder ret = new StringBuilder();
		
		if(neg)
			ret.append("-");
		
		if(hr < 10)
			ret.append("0");
		ret.append(hr).append(":");
		if(min < 10)
			ret.append("0");
		ret.append(min).append(":");		
		if(sek < 10)
			ret.append("0");
		ret.append(sek);
		
		return ret.toString(); 
	}
	
	public static float toDouble(int hr, int min, int sek)
	{
		return hr*60*60 + min*60 + sek;
	}

	public void onEvent(Event e)
	{
		if(e.isMsg(World.EVENT_TICK))
		{
			tcount++;
			time += delta_time;
			
			if(stop_time != -1 && time >= stop_time)
				((World)e.getSource()).stop();				
		}
	}
	
	public static void main(String[] args) throws Exception
	{
		System.out.println(format(toDouble(14, 15, 28)));
		System.out.println(format(-1*toDouble(2,10,50)));
	}
}
